/*
    Copyright (C) 2003 Alan Broun

    This file is part of Camel.

    Camel is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Camel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Camel; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//------------------------------------------------------------------------------
// File: Bomb.h
// Desc: This entity can be dropped by planes to cause mucho devastation
//------------------------------------------------------------------------------

#ifndef _BOMB_H_
#define _BOMB_H_

//------------------------------------------------------------------------------
// Include Files
//------------------------------------------------------------------------------
#include "Entity.h"

class Bomb : public Entity
{
protected:
    enum BOMB_ACTIONS {
        CHECK_DIRECTION,
        NUM_ACTIONS
    };

    // Rates for various actions are measured in milliseconds
    static const int CHECKING_DIRECTION_RATE;

    ACTION *Actions[NUM_ACTIONS];
    Point2D WorldPosLastDirectionCheck;
    XY_COMPONENT VelocityVector;      // Pixels per second
    int Direction;
    
    Bomb();
    inline void CalcFrame();

    static void Check_Direction(void *Object);
public:
    Bomb(Level *L, Point2D CentrePos, int Direction, float Velocity);
    ~Bomb();

    void Update(uint dt);
    void FindAndHandleCollisionWithLandscape();
	void HandleCollision(Entity *AnEntity);
};

#endif // _BOMB_H_
