/*
    Copyright (C) 2003 Alan Broun

    This file is part of Camel.

    Camel is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Camel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Camel; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//------------------------------------------------------------------------------
// File: Flag.h
// Desc: The game of Camel is essentially a game of capture the flag. This
//       entity represents that flag, when a soldier (or tank) from touchs the
//       flag of the opposing side then the game is over and the side that
//       captured the flag has won.
//------------------------------------------------------------------------------

#ifndef _FLAG_H_
#define _FLAG_H_

//------------------------------------------------------------------------------
// Include Files
//------------------------------------------------------------------------------
#include "Entity.h"

class Flag : public Entity
{
public:
    static const int POINTS_VALUE;
protected:
    bool Captured;  // Has this flag been captured by the enemy?
public:
    Flag(Level *L, int x, ENT_SIDE Side);
    ~Flag();

    bool GetCaptured() { return Captured; }
    void Update(uint dt);
    void FindAndHandleCollisionWithLandscape() {}
	void HandleCollision(Entity *AnEntity);
};

#endif // _FLAG_H_
