/*
    Copyright (C) 2003 Alan Broun

    This file is part of Camel.

    Camel is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Camel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Camel; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//------------------------------------------------------------------------------
// File: Camel.cpp
// Desc: A really great game. I hope...
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Include Files
//------------------------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>
#include "CamelUtility.h"
#include "SDL_Interface.h"
#include "Camel.h"
#include "Game.h"

CU_TIMINGFRAMEDATA TFData0;
CU_TIMINGFRAMEDATA TFDatat =     { "Main Loop", CAM_P_ACTIVE_TIME, -1 };

CU_TIMINGFRAMEDATA TFData[] = {
//      Name,        First Child,    Next
    { "Main Loop", CAM_P_ACTIVE_TIME, -1 },                         
    { "Active Time", CAM_P_UPDATE_ENTITIES, CAM_P_IDLE_TIME },                    
    { "Update Entities", -1, CAM_P_DRAW_BACKGROUND },           
    { "Draw Background", -1, CAM_P_DRAW_ENTITIES },           
    { "Draw Entities", CAM_P_DRAW_ALPHA_ENTITIES, CAM_P_DRAW_FOREGROUND },             
    { "Draw Alpha Entities", -1, CAM_P_DRAW_NON_ALPHA_ENTITIES },
    { "Draw Non Alpha Entities", -1, -1 },
    { "Draw Foreground", -1, -1 },          
    { "Idle Time", -1, -1 }                     
};

int main(int argc, char* argv[])
{
    Game *G = Game::GetInstance();

    // Set up the profiler
    CU_InitialiseProfiling(TFData);
    CU_STARTFRAME(CAM_P_MAIN_LOOP);
    CU_STARTFRAME(CAM_P_IDLE_TIME);

    G->RunMainLoop();

    CU_ENDFRAME(CAM_P_IDLE_TIME);
    CU_ENDFRAME(CAM_P_MAIN_LOOP);
    CU_PrintProfilingResults();

    delete G;

    return 0;
}
