/*
    Copyright (C) 2003 Alan Broun

    This file is part of Camel.

    Camel is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Camel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Camel; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

//------------------------------------------------------------------------------
// File: SmokeParticle.cpp
// Desc: Small entity that exists for a limited amount of time and then
//       just disappears
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Include Files
//------------------------------------------------------------------------------
#include <assert.h>
#include "Sprites.h"
#include "SmokeParticle.h"

//------------------------------------------------------------------------------
// SmokeParticle Implementation
//------------------------------------------------------------------------------
SmokeParticle::SmokeParticle(Level *L, uint TimeLeft, Point2D Pos) : Entity(L)
{
    Type = PARTICLE;
    this->TimeLeft = TimeLeft;
    WorldPos = Pos;
    Frame = Sprites::SMOKEPARTICLE_SPRITE;
    SPR->GetFrameDims(Sprites::SMOKEPARTICLE_SPRITE, &Width, &Height);
}

SmokeParticle::~SmokeParticle() {}

void SmokeParticle::Update(uint dt)
{
    TimeLeft -= dt;
    if (TimeLeft <= 0) NeedsDeletion = true;
}
